Index: usr.bin/procstat/procstat_args.c
===================================================================
RCS file: usr.bin/procstat/procstat_args.c
diff -N usr.bin/procstat/procstat_args.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ usr.bin/procstat/procstat_args.c	17 Jan 2008 19:30:46 -0000
@@ -0,0 +1,76 @@
+/*-
+ * Copyright (c) 2007 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD: src/usr.bin/procstat/procstat_args.c,v 1.2 2007/12/10 20:55:43 rwatson Exp $
+ */
+
+#include <sys/types.h>
+#include <sys/sysctl.h>
+#include <sys/user.h>
+
+#include <err.h>
+#include <errno.h>
+#include <limits.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+
+#include "procstat.h"
+
+static char args[ARG_MAX];
+
+void
+procstat_args(pid_t pid, struct kinfo_proc *kipp)
+{
+	int error, name[4];
+	size_t len;
+	char *cp;
+
+	if (!hflag)
+		printf("%5s %-16s %-53s\n", "PID", "COMM", "ARGS");
+
+	name[0] = CTL_KERN;
+	name[1] = KERN_PROC;
+	name[2] = KERN_PROC_ARGS;
+	name[3] = pid;
+	len = sizeof(args);
+	error = sysctl(name, 4, args, &len, NULL, 0);
+	if (error < 0 && errno != ESRCH) {
+		warn("sysctl: kern.proc.args: %d", pid);
+		return;
+	}
+	if (error < 0)
+		return;
+	if (len == 0 || strlen(args) == 0) {
+		strcpy(args, "-");
+		len = strlen(args) + 1;
+	}
+
+	printf("%5d ", pid);
+	printf("%-16s ", kipp->ki_comm);
+	for (cp = args; cp < args + len; cp += strlen(cp) + 1)
+		printf("%s%s", cp != args ? " " : "", cp);
+	printf("\n");
+}
Index: usr.bin/procstat/procstat_basic.c
===================================================================
RCS file: usr.bin/procstat/procstat_basic.c
diff -N usr.bin/procstat/procstat_basic.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ usr.bin/procstat/procstat_basic.c	17 Jan 2008 19:30:46 -0000
@@ -0,0 +1,64 @@
+/*-
+ * Copyright (c) 2007 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD: src/usr.bin/procstat/procstat_basic.c,v 1.1 2007/12/02 23:31:45 rwatson Exp $
+ */
+
+#include <sys/types.h>
+#include <sys/sysctl.h>
+#include <sys/user.h>
+
+#include <err.h>
+#include <stdio.h>
+#include <string.h>
+
+#include "procstat.h"
+
+void
+procstat_basic(pid_t pid, struct kinfo_proc *kipp)
+{
+
+	if (!hflag)
+		printf("%5s %5s %5s %5s %5s %3s %-8s %-9s %-13s %-12s\n",
+		    "PID", "PPID", "PGID", "SID", "TSID", "THR", "LOGIN",
+		    "WCHAN", "EMUL", "COMM");
+
+	printf("%5d ", kipp->ki_pid);
+	printf("%5d ", kipp->ki_ppid);
+	printf("%5d ", kipp->ki_pgid);
+	printf("%5d ", kipp->ki_sid);
+	printf("%5d ", kipp->ki_tsid);
+	printf("%3d ", kipp->ki_numthreads);
+	printf("%-8s ", strlen(kipp->ki_login) ? kipp->ki_login : "-");
+	if (kipp->ki_kiflag & KI_LOCKBLOCK) {
+		printf("*%-8s ", strlen(kipp->ki_lockname) ?
+		    kipp->ki_lockname : "-");
+	} else {
+		printf("%-9s ", strlen(kipp->ki_wmesg) ?
+		    kipp->ki_wmesg : "-");
+	}
+	printf("%-13s ", strcmp(kipp->ki_emul, "null") ? kipp->ki_emul : "-");
+	printf("%-12s\n", kipp->ki_comm);
+}
Index: usr.bin/procstat/procstat_bin.c
===================================================================
RCS file: usr.bin/procstat/procstat_bin.c
diff -N usr.bin/procstat/procstat_bin.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ usr.bin/procstat/procstat_bin.c	17 Jan 2008 19:30:46 -0000
@@ -0,0 +1,70 @@
+/*-
+ * Copyright (c) 2007 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD: src/usr.bin/procstat/procstat_bin.c,v 1.2 2007/12/10 20:55:43 rwatson Exp $
+ */
+
+#include <sys/types.h>
+#include <sys/sysctl.h>
+#include <sys/user.h>
+
+#include <err.h>
+#include <errno.h>
+#include <limits.h>
+#include <stdio.h>
+#include <string.h>
+
+#include "procstat.h"
+
+void
+procstat_bin(pid_t pid, struct kinfo_proc *kipp)
+{
+	char pathname[PATH_MAX];
+	int error, name[4];
+	size_t len;
+
+	if (!hflag)
+		printf("%5s %-16s %-53s\n", "PID", "COMM", "PATH");
+
+	name[0] = CTL_KERN;
+	name[1] = KERN_PROC;
+	name[2] = KERN_PROC_PATHNAME;
+	name[3] = pid;
+
+	len = sizeof(pathname);
+	error = sysctl(name, 4, pathname, &len, NULL, 0);
+	if (error < 0 && errno != ESRCH) {
+		warn("sysctl: kern.proc.pathname: %d", pid);
+		return;
+	}
+	if (error < 0)
+		return;
+	if (len == 0 || strlen(pathname) == 0)
+		strcpy(pathname, "-");
+
+	printf("%5d ", pid);
+	printf("%-16s ", kipp->ki_comm);
+	printf("%s\n", pathname);
+}
Index: usr.bin/procstat/procstat_cred.c
===================================================================
RCS file: usr.bin/procstat/procstat_cred.c
diff -N usr.bin/procstat/procstat_cred.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ usr.bin/procstat/procstat_cred.c	17 Jan 2008 19:30:46 -0000
@@ -0,0 +1,59 @@
+/*-
+ * Copyright (c) 2007 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD: src/usr.bin/procstat/procstat_cred.c,v 1.2 2007/12/10 20:55:43 rwatson Exp $
+ */
+
+#include <sys/types.h>
+#include <sys/sysctl.h>
+#include <sys/user.h>
+
+#include <err.h>
+#include <stdio.h>
+
+#include "procstat.h"
+
+void
+procstat_cred(pid_t pid, struct kinfo_proc *kipp)
+{
+	int i;
+
+	if (!hflag)
+		printf("%5s %-16s %5s %5s %5s %5s %5s %5s %-20s\n", "PID",
+		    "COMM", "EUID", "RUID", "SVUID", "EGID", "RGID", "SVGID",
+		    "GROUPS");
+
+	printf("%5d ", pid);
+	printf("%-16s ", kipp->ki_comm);
+	printf("%5d ", kipp->ki_uid);
+	printf("%5d ", kipp->ki_ruid);
+	printf("%5d ", kipp->ki_svuid);
+	printf("%5d ", kipp->ki_groups[0]);
+	printf("%5d ", kipp->ki_rgid);
+	printf("%5d ", kipp->ki_svgid);
+	for (i = 0; i < kipp->ki_ngroups; i++)
+		printf("%s%d", (i > 0) ? "," : "", kipp->ki_groups[i]);
+	printf("\n");
+}
Index: usr.bin/procstat/procstat_files.c
===================================================================
RCS file: usr.bin/procstat/procstat_files.c
diff -N usr.bin/procstat/procstat_files.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ usr.bin/procstat/procstat_files.c	17 Jan 2008 19:30:46 -0000
@@ -0,0 +1,306 @@
+/*-
+ * Copyright (c) 2007 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD: src/usr.bin/procstat/procstat_files.c,v 1.2 2007/12/10 20:55:43 rwatson Exp $
+ */
+
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <sys/sysctl.h>
+#include <sys/un.h>
+#include <sys/user.h>
+
+#include <netinet/in.h>
+
+#include <arpa/inet.h>
+
+#include <err.h>
+#include <inttypes.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+
+#include "procstat.h"
+
+static const char *
+protocol_to_string(int domain, int type, int protocol)
+{
+
+	switch (domain) {
+	case AF_INET:
+	case AF_INET6:
+		switch (protocol) {
+		case IPPROTO_TCP:
+			return ("TCP");
+		case IPPROTO_UDP:
+			return ("UDP");
+		case IPPROTO_ICMP:
+			return ("ICM");
+		case IPPROTO_RAW:
+			return ("RAW");
+		case IPPROTO_SCTP:
+			return ("SCT");
+		case IPPROTO_DIVERT:
+			return ("IPD");
+		default:
+			return ("IP?");
+		}
+
+	case AF_LOCAL:
+		switch (type) {
+		case SOCK_STREAM:
+			return ("UDS");
+		case SOCK_DGRAM:
+			return ("UDD");
+		default:
+			return ("UD?");
+		}
+	default:
+		return ("?");
+	}
+}
+
+static void
+addr_to_string(struct sockaddr_storage *ss, char *buffer, int buflen)
+{
+	char buffer2[INET6_ADDRSTRLEN];
+	struct sockaddr_in6 *sin6;
+	struct sockaddr_in *sin;
+	struct sockaddr_un *sun;
+
+	switch (ss->ss_family) {
+	case AF_LOCAL:
+		sun = (struct sockaddr_un *)ss;
+		if (strlen(sun->sun_path) == 0)
+			strlcpy(buffer, "-", buflen);
+		else
+			strlcpy(buffer, sun->sun_path, buflen);
+		break;
+
+	case AF_INET:
+		sin = (struct sockaddr_in *)ss;
+		snprintf(buffer, buflen, "%s:%d", inet_ntoa(sin->sin_addr),
+		    ntohs(sin->sin_port));
+		break;
+
+	case AF_INET6:
+		sin6 = (struct sockaddr_in6 *)ss;
+		if (inet_ntop(AF_INET6, &sin6->sin6_addr, buffer2,
+		    sizeof(buffer2)) != NULL)
+			snprintf(buffer, buflen, "%s.%d", buffer2,
+			    ntohs(sin6->sin6_port));
+		else
+			strlcpy(buffer, "-", sizeof(buffer));
+		break;
+
+	default:
+		strlcpy(buffer, "", buflen);
+		break;
+	}
+}
+
+static void
+print_address(struct sockaddr_storage *ss)
+{
+	char addr[PATH_MAX];
+
+	addr_to_string(ss, addr, sizeof(addr));
+	printf("%s", addr);
+}
+
+void
+procstat_files(pid_t pid, struct kinfo_proc *kipp)
+{
+	struct kinfo_file *freep, *kif;
+	int error, i, name[4];
+	const char *str;
+	size_t len;
+
+	if (!hflag)
+		printf("%5s %-16s %3s %1s %1s %-8s %3s %7s %-3s %-12s\n",
+		    "PID", "COMM", "FD", "T", "V", "FLAGS", "REF", "OFFSET",
+		    "PRO", "NAME");
+
+	name[0] = CTL_KERN;
+	name[1] = KERN_PROC;
+	name[2] = KERN_PROC_FILEDESC;
+	name[3] = pid;
+
+	error = sysctl(name, 4, NULL, &len, NULL, 0);
+	if (error < 0 && errno != ESRCH && errno != EPERM) {
+		warn("sysctl: kern.proc.filedesc: %d", pid);
+		return;
+	}
+	if (error < 0)
+		return;
+
+	freep = kif = malloc(len);
+	if (kif == NULL)
+		err(-1, "malloc");
+
+	if (sysctl(name, 4, kif, &len, NULL, 0) < 0) {
+		warn("sysctl: kern.proc.filedesc %d", pid);
+		free(freep);
+		return;
+	}
+
+	for (i = 0; i < len / sizeof(*kif); i++, kif++) {
+		if (kif->kf_structsize != sizeof(*kif))
+			errx(-1, "kinfo_file mismatch");
+		printf("%5d ", pid);
+		printf("%-16s ", kipp->ki_comm);
+		printf("%3d ", kif->kf_fd);
+		switch (kif->kf_type) {
+		case KF_TYPE_VNODE:
+			str = "v";
+			break;
+
+		case KF_TYPE_SOCKET:
+			str = "s";
+			break;
+
+		case KF_TYPE_PIPE:
+			str = "p";
+			break;
+
+		case KF_TYPE_FIFO:
+			str = "f";
+			break;
+
+		case KF_TYPE_KQUEUE:
+			str = "k";
+			break;
+
+		case KF_TYPE_CRYPTO:
+			str = "c";
+			break;
+
+		case KF_TYPE_MQUEUE:
+			str = "m";
+			break;
+
+		case KF_TYPE_NONE:
+		case KF_TYPE_UNKNOWN:
+		default:
+			str = "?";
+			break;
+		}
+		printf("%1s ", str);
+		str = "-";
+		if (kif->kf_type == KF_TYPE_VNODE) {
+			switch (kif->kf_vnode_type) {
+			case KF_VTYPE_VREG:
+				str = "r";
+				break;
+
+			case KF_VTYPE_VDIR:
+				str = "d";
+				break;
+
+			case KF_VTYPE_VBLK:
+				str = "b";
+				break;
+
+			case KF_VTYPE_VCHR:
+				str = "c";
+				break;
+
+			case KF_VTYPE_VLNK:
+				str = "l";
+				break;
+
+			case KF_VTYPE_VSOCK:
+				str = "s";
+				break;
+
+			case KF_VTYPE_VFIFO:
+				str = "f";
+				break;
+
+			case KF_VTYPE_VBAD:
+				str = "x";
+				break;
+
+			case KF_VTYPE_VNON:
+			case KF_VTYPE_UNKNOWN:
+			default:
+				str = "?";
+				break;
+			}
+		}
+		printf("%1s ", str);
+		printf("%s", kif->kf_flags & KF_FLAG_READ ? "r" : "-");
+		printf("%s", kif->kf_flags & KF_FLAG_WRITE ? "w" : "-");
+		printf("%s", kif->kf_flags & KF_FLAG_APPEND ? "a" : "-");
+		printf("%s", kif->kf_flags & KF_FLAG_ASYNC ? "s" : "-");
+		printf("%s", kif->kf_flags & KF_FLAG_FSYNC ? "f" : "-");
+		printf("%s", kif->kf_flags & KF_FLAG_NONBLOCK ? "n" : "-");
+		printf("%s", kif->kf_flags & KF_FLAG_DIRECT ? "d" : "-");
+		printf("%s ", kif->kf_flags & KF_FLAG_HASLOCK ? "l" : "-");
+		printf("%3d ", kif->kf_ref_count);
+		printf("%7jd ", (intmax_t)kif->kf_offset);
+
+		switch (kif->kf_type) {
+		case KF_TYPE_VNODE:
+		case KF_TYPE_FIFO:
+			printf("%-3s ", "-");
+			printf("%-18s", kif->kf_path);
+			break;
+
+		case KF_TYPE_SOCKET:
+			printf("%-3s ",
+			    protocol_to_string(kif->kf_sock_domain,
+			    kif->kf_sock_type, kif->kf_sock_protocol));
+			/*
+			 * While generally we like to print two addresses,
+			 * local and peer, for sockets, it turns out to be
+			 * more useful to print the first non-nul address for
+			 * local sockets, as typically they aren't bound and
+			 *  connected, and the path strings can get long.
+			 */
+			if (kif->kf_sock_domain == AF_LOCAL) {
+				struct sockaddr_un *sun =
+				    (struct sockaddr_un *)&kif->kf_sa_local;
+
+				if (sun->sun_path[0] != 0)
+					print_address(&kif->kf_sa_local);
+				else
+					print_address(&kif->kf_sa_peer);
+			} else {
+				print_address(&kif->kf_sa_local);
+				printf(" ");
+				print_address(&kif->kf_sa_peer);
+			}
+			break;
+
+		default:
+			printf("%-3s ", "-");
+			printf("%-18s", "-");
+		}
+
+		printf("\n");
+	}
+	free(freep);
+}
Index: usr.bin/procstat/procstat_kstack.c
===================================================================
RCS file: usr.bin/procstat/procstat_kstack.c
diff -N usr.bin/procstat/procstat_kstack.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ usr.bin/procstat/procstat_kstack.c	17 Jan 2008 19:30:46 -0000
@@ -0,0 +1,245 @@
+/*-
+ * Copyright (c) 2007 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD: src/usr.bin/procstat/procstat_kstack.c,v 1.2 2007/12/03 21:21:15 rwatson Exp $
+ */
+
+#include <sys/types.h>
+#include <sys/sysctl.h>
+#include <sys/user.h>
+
+#include <err.h>
+#include <errno.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+
+#include "procstat.h"
+
+/*
+ * Walk the stack trace provided by the kernel and reduce it to what we
+ * actually want to print.  This involves stripping true instruction pointers,
+ * frame numbers, and carriage returns as generated by stack(9).  If -kk is
+ * specified, print the function and offset, otherwise just the function.
+ */
+enum trace_state { TS_FRAMENUM, TS_PC, TS_AT, TS_FUNC, TS_OFF };
+
+static enum trace_state
+kstack_nextstate(enum trace_state ts)
+{
+
+	switch (ts) {
+	case TS_FRAMENUM:
+		return (TS_PC);
+
+	case TS_PC:
+		return (TS_AT);
+
+	case TS_AT:
+		return (TS_FUNC);
+
+	case TS_FUNC:
+		return (TS_OFF);
+
+	case TS_OFF:
+		return TS_FRAMENUM;
+
+	default:
+		errx(-1, "kstack_nextstate");
+	}
+}
+
+static void
+kstack_cleanup(const char *old, char *new, int kflag)
+{
+	enum trace_state old_ts, ts;
+	const char *cp_old;
+	char *cp_new;
+
+	ts = TS_FRAMENUM;
+	for (cp_old = old, cp_new = new; *cp_old != '\0'; cp_old++) {
+		switch (*cp_old) {
+		case ' ':
+		case '\n':
+		case '+':
+			old_ts = ts;
+			ts = kstack_nextstate(old_ts);
+			if (old_ts == TS_OFF) {
+				*cp_new = ' ';
+				cp_new++;
+			}
+			if (kflag > 1 && old_ts == TS_FUNC) {
+				*cp_new = '+';
+				cp_new++;
+			}
+			continue;
+		}
+		if (ts == TS_FUNC || (kflag > 1 && ts == TS_OFF)) {
+			*cp_new = *cp_old;
+			cp_new++;
+		}
+	}
+	*cp_new = '\0';
+}
+
+/*
+ * Sort threads by tid.
+ */
+static int
+kinfo_kstack_compare(const void *a, const void *b)
+{
+
+        return ((struct kinfo_kstack *)a)->kkst_tid -
+            ((struct kinfo_kstack *)b)->kkst_tid;
+}
+
+static void
+kinfo_kstack_sort(struct kinfo_kstack *kkstp, int count)
+{
+
+        qsort(kkstp, count, sizeof(*kkstp), kinfo_kstack_compare);
+}
+
+
+void
+procstat_kstack(pid_t pid, struct kinfo_proc *kipp, int kflag)
+{
+	struct kinfo_kstack *kkstp, *kkstp_free;
+	struct kinfo_proc *kip, *kip_free;
+	char trace[KKST_MAXLEN];
+	int error, i, j, name[4];
+	size_t kip_len, kstk_len;
+
+	if (!hflag)
+		printf("%5s %6s %-16s %-16s %-29s\n", "PID", "TID", "COMM",
+		    "TDNAME", "KSTACK");
+
+	name[0] = CTL_KERN;
+	name[1] = KERN_PROC;
+	name[2] = KERN_PROC_KSTACK;
+	name[3] = pid;
+
+	kstk_len = 0;
+	error = sysctl(name, 4, NULL, &kstk_len, NULL, 0);
+	if (error < 0 && errno != ESRCH && errno != EPERM && errno != ENOENT) {
+		warn("sysctl: kern.proc.kstack: %d", pid);
+		return;
+	}
+	if (error < 0 && errno == ENOENT) {
+		warnx("sysctl: kern.proc.kstack unavailable");
+		errx(-1, "options DDB or options STACK required in kernel");
+	}
+	if (error < 0)
+		return;
+
+	kkstp = kkstp_free = malloc(kstk_len);
+	if (kkstp == NULL)
+		err(-1, "malloc");
+
+	if (sysctl(name, 4, kkstp, &kstk_len, NULL, 0) < 0) {
+		warn("sysctl: kern.proc.pid: %d", pid);
+		free(kkstp);
+		return;
+	}
+
+	/*
+	 * We need to re-query for thread information, so don't use *kipp.
+	 */
+	name[0] = CTL_KERN;
+	name[1] = KERN_PROC;
+	name[2] = KERN_PROC_PID | KERN_PROC_INC_THREAD;
+	name[3] = pid;
+
+	kip_len = 0;
+	error = sysctl(name, 4, NULL, &kip_len, NULL, 0);
+	if (error < 0 && errno != ESRCH) {
+		warn("sysctl: kern.proc.pid: %d", pid);
+		return;
+	}
+	if (error < 0)
+		return;
+
+	kip = kip_free = malloc(kip_len);
+	if (kip == NULL)
+		err(-1, "malloc");
+
+	if (sysctl(name, 4, kip, &kip_len, NULL, 0) < 0) {
+		warn("sysctl: kern.proc.pid: %d", pid);
+		free(kip);
+		return;
+	}
+
+	kinfo_kstack_sort(kkstp, kstk_len / sizeof(*kkstp));
+	for (i = 0; i < kstk_len / sizeof(*kkstp); i++) {
+		kkstp = &kkstp_free[i];
+
+		/*
+		 * Look up the specific thread using its tid so we can
+		 * display the per-thread command line.
+		 */
+		kipp = NULL;
+		for (j = 0; j < kip_len / sizeof(*kipp); j++) {
+			kipp = &kip_free[j];
+			if (kkstp->kkst_tid == kipp->ki_tid)
+				break;
+		}
+		if (kipp == NULL)
+			continue;
+
+		printf("%5d ", pid);
+		printf("%6d ", kkstp->kkst_tid);
+		printf("%-16s ", kipp->ki_comm);
+		printf("%-16s ", (strlen(kipp->ki_ocomm) &&
+		    (strcmp(kipp->ki_comm, kipp->ki_ocomm) != 0)) ?
+		    kipp->ki_ocomm : "-");
+
+		switch (kkstp->kkst_state) {
+		case KKST_STATE_RUNNING:
+			printf("%-29s\n", "<running>");
+			continue;
+
+		case KKST_STATE_SWAPPED:
+			printf("%-29s\n", "<swapped>");
+			continue;
+
+		case KKST_STATE_STACKOK:
+			break;
+
+		default:
+			printf("%-29s\n", "<unknown>");
+			continue;
+		}
+
+		/*
+		 * The kernel generates a trace with carriage returns between
+		 * entries, but for a more compact view, we convert carriage
+		 * returns to spaces.
+		 */
+		kstack_cleanup(kkstp->kkst_trace, trace, kflag);
+		printf("%-29s\n", trace);
+	}
+	free(kip_free);
+	free(kkstp_free);
+}
Index: usr.bin/procstat/procstat_threads.c
===================================================================
RCS file: usr.bin/procstat/procstat_threads.c
diff -N usr.bin/procstat/procstat_threads.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ usr.bin/procstat/procstat_threads.c	17 Jan 2008 19:30:46 -0000
@@ -0,0 +1,141 @@
+/*-
+ * Copyright (c) 2007 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD: src/usr.bin/procstat/procstat_threads.c,v 1.2 2007/12/03 21:21:15 rwatson Exp $
+ */
+
+#include <sys/types.h>
+#include <sys/sysctl.h>
+#include <sys/user.h>
+
+#include <err.h>
+#include <errno.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+
+#include "procstat.h"
+
+void
+procstat_threads(pid_t pid, struct kinfo_proc *kipp)
+{
+	struct kinfo_proc *kip;
+	int error, i, name[4];
+	const char *str;
+	size_t len;
+
+	if (!hflag)
+		printf("%5s %6s %-16s %-16s %2s %4s %-7s %-9s\n", "PID",
+		    "TID", "COMM", "TDNAME", "CPU", "PRI", "STATE", "WCHAN");
+
+	/*
+	 * We need to re-query for thread information, so don't use *kipp.
+	 */
+	name[0] = CTL_KERN;
+	name[1] = KERN_PROC;
+	name[2] = KERN_PROC_PID | KERN_PROC_INC_THREAD;
+	name[3] = pid;
+
+	len = 0;
+	error = sysctl(name, 4, NULL, &len, NULL, 0);
+	if (error < 0 && errno != ESRCH) {
+		warn("sysctl: kern.proc.pid: %d", pid);
+		return;
+	}
+	if (error < 0)
+		return;
+
+	kip = malloc(len);
+	if (kip == NULL)
+		err(-1, "malloc");
+
+	if (sysctl(name, 4, kip, &len, NULL, 0) < 0) {
+		warn("sysctl: kern.proc.pid: %d", pid);
+		free(kip);
+		return;
+	}
+
+	kinfo_proc_sort(kip, len / sizeof(*kipp));
+	for (i = 0; i < len / sizeof(*kipp); i++) {
+		kipp = &kip[i];
+		printf("%5d ", pid);
+		printf("%6d ", kipp->ki_tid);
+		printf("%-16s ", strlen(kipp->ki_comm) ?
+		    kipp->ki_comm : "-");
+		printf("%-16s ", (strlen(kipp->ki_ocomm) &&
+		    (strcmp(kipp->ki_comm, kipp->ki_ocomm) != 0)) ?
+		    kipp->ki_ocomm : "-");
+		if (kipp->ki_oncpu != 255)
+			printf("%3d ", kipp->ki_oncpu);
+		else if (kipp->ki_lastcpu != 255)
+			printf("%3d ", kipp->ki_lastcpu);
+		else
+			printf("%3s ", "-");
+		printf("%4d ", kipp->ki_pri.pri_level);
+		switch (kipp->ki_stat) {
+		case SRUN:
+			str = "run";
+			break;
+
+		case SSTOP:
+			str = "stop";
+			break;
+
+		case SSLEEP:
+			str = "sleep";
+			break;
+
+		case SLOCK:
+			str = "lock";
+			break;
+
+		case SWAIT:
+			str = "wait";
+			break;
+
+		case SZOMB:
+			str = "zomb";
+			break;
+
+		case SIDL:
+			str = "idle";
+			break;
+
+		default:
+			str = "??";
+			break;
+		}
+		printf("%-7s ", str);
+		if (kipp->ki_kiflag & KI_LOCKBLOCK) {
+			printf("*%-8s ", strlen(kipp->ki_lockname) ?
+			    kipp->ki_lockname : "-");
+		} else {
+			printf("%-9s ", strlen(kipp->ki_wmesg) ?
+			    kipp->ki_wmesg : "-");
+		}
+		printf("\n");
+	}
+	free(kip);
+}
